
#include "opencv2/core.hpp"

#include "opencv2/xphoto.hpp"

#include "white-ballance.hpp"

using namespace cv;

extern "C" {
Ptr_GrayworldWB * inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_0_4fd73c46202741401678ebad8803d1640b421482(double cvarThreshold_27_inline_c_0) {

      cv::Ptr<cv::xphoto::GrayworldWB> wbAlg = cv::xphoto::createGrayworldWB ();
      wbAlg->setSaturationThreshold(cvarThreshold_27_inline_c_0);
      return new cv::Ptr<cv::xphoto::GrayworldWB>(wbAlg);
    
}

}

extern "C" {
Ptr_LearningBasedWB * inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_1_0692032a7bec02f065f9e8e1c88aeec372b3efe9(int cvarHistBinNum_27_inline_c_0, int cvarRangeMaxVal_27_inline_c_1, double cvarSaturationThreshold_27_inline_c_2) {

      cv::Ptr<cv::xphoto::LearningBasedWB> wbAlg = cv::xphoto::createLearningBasedWB ();
      wbAlg->setHistBinNum(cvarHistBinNum_27_inline_c_0);
      wbAlg->setRangeMaxVal(cvarRangeMaxVal_27_inline_c_1);
      wbAlg->setSaturationThreshold(cvarSaturationThreshold_27_inline_c_2);
      return new cv::Ptr<cv::xphoto::LearningBasedWB>(wbAlg);
    
}

}

extern "C" {
Ptr_SimpleWB * inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_2_4ecea8417cf34021c3e52bee10fb9be4499827ea(double cvarIMin_27_inline_c_0, double cvarIMax_27_inline_c_1, double cvarOMin_27_inline_c_2, double cvarOMax_27_inline_c_3, double cvarP_27_inline_c_4) {

      cv::Ptr<cv::xphoto::SimpleWB> wbAlg = cv::xphoto::createSimpleWB ();
      wbAlg->setInputMin( cvarIMin_27_inline_c_0);
      wbAlg->setInputMax( cvarIMax_27_inline_c_1);
      wbAlg->setOutputMin(cvarOMin_27_inline_c_2);
      wbAlg->setOutputMax(cvarOMax_27_inline_c_3);
      wbAlg->setP(cvarP_27_inline_c_4);
      return new cv::Ptr<cv::xphoto::SimpleWB>(wbAlg);
    
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_3_2378626bf54d7674c38c44cac881e7801e57d543(Ptr_SimpleWB * wbAlgPtr_inline_c_0, Mat * imgInPtr_inline_c_1, Mat * imgOutPtr_inline_c_2) {

              cv::xphoto::SimpleWB * wb = *wbAlgPtr_inline_c_0;
              wb->balanceWhite
              ( *imgInPtr_inline_c_1
              , *imgOutPtr_inline_c_2
              );
            
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_4_9c296a6aea62311d052959acbc63d86a7c62253b(Ptr_LearningBasedWB * wbAlgPtr_inline_c_0, Mat * imgInPtr_inline_c_1, Mat * imgOutPtr_inline_c_2) {

              cv::xphoto::LearningBasedWB * wb = *wbAlgPtr_inline_c_0;
              wb->balanceWhite
              ( *imgInPtr_inline_c_1
              , *imgOutPtr_inline_c_2
              );
            
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_5_80e5036bd319618f74258d98ddd7b0d8f641651b(Ptr_GrayworldWB * wbAlgPtr_inline_c_0, Mat * imgInPtr_inline_c_1, Mat * imgOutPtr_inline_c_2) {

              cv::xphoto::GrayworldWB * wb = *wbAlgPtr_inline_c_0;
              wb->balanceWhite
              ( *imgInPtr_inline_c_1
              , *imgOutPtr_inline_c_2
              );
            
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_6_3326c72a78f150bf51e4e5874c00ca2e9deed8ec(Ptr_SimpleWB * knnPtr_inline_c_0) {

              cv::xphoto::SimpleWB * knn = *knnPtr_inline_c_0;
              knn->clear();
          
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_7_f5f092be98dedc30e21c12bd8c827d45feeeac9f(Ptr_SimpleWB * knnPtr_inline_c_0, bool * emptyPtr_inline_c_1) {

              cv::xphoto::SimpleWB * knn = *knnPtr_inline_c_0;
              *emptyPtr_inline_c_1 = knn->empty();
          
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_8_8d9092fd1aec4fa0c8ea6ce464757e5b4a90738f(Ptr_LearningBasedWB * knnPtr_inline_c_0) {

              cv::xphoto::LearningBasedWB * knn = *knnPtr_inline_c_0;
              knn->clear();
          
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_9_fb6d5b983e28c8b8df2c941c172abb66b3802cea(Ptr_LearningBasedWB * knnPtr_inline_c_0, bool * emptyPtr_inline_c_1) {

              cv::xphoto::LearningBasedWB * knn = *knnPtr_inline_c_0;
              *emptyPtr_inline_c_1 = knn->empty();
          
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_10_c7381c418d45bf665351fc19c11208bbda9dff4f(Ptr_GrayworldWB * knnPtr_inline_c_0) {

              cv::xphoto::GrayworldWB * knn = *knnPtr_inline_c_0;
              knn->clear();
          
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_11_d692009848de0a973eeb08ab410c913952046b11(Ptr_GrayworldWB * knnPtr_inline_c_0, bool * emptyPtr_inline_c_1) {

              cv::xphoto::GrayworldWB * knn = *knnPtr_inline_c_0;
              *emptyPtr_inline_c_1 = knn->empty();
          
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_12_97c5d79b5414aedba9c9d3333bfc0d26531e5bdb(Ptr_SimpleWB * ptr_inline_c_0) {

                  cv::Ptr<cv::xphoto::SimpleWB> * knn_ptr_ptr =
                    ptr_inline_c_0;
                  knn_ptr_ptr->release();
                  delete knn_ptr_ptr;
                
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_13_680790a74227e4ede15c2bb1a2657d8b4e6969eb(Ptr_LearningBasedWB * ptr_inline_c_0) {

                  cv::Ptr<cv::xphoto::LearningBasedWB> * knn_ptr_ptr =
                    ptr_inline_c_0;
                  knn_ptr_ptr->release();
                  delete knn_ptr_ptr;
                
}

}

extern "C" {
void inline_c_OpenCV_Extra_XPhoto_WhiteBalancer_14_1ec8441459880af3f8a2cb39d16f08188b544e0e(Ptr_GrayworldWB * ptr_inline_c_0) {

                  cv::Ptr<cv::xphoto::GrayworldWB> * knn_ptr_ptr =
                    ptr_inline_c_0;
                  knn_ptr_ptr->release();
                  delete knn_ptr_ptr;
                
}

}
